#ifndef S_H
#define S_H

class A
{
public:
    A() {}
    virtual ~A() {}
protected:
    static int bar() { return 3; }
};

class B: public A
{
public:
    B(): A() {}
    virtual ~B() {}
private:
    static int bar(int oops) { return 0; }
};

class C: public A
{
protected:
    C(): A() {}
    virtual ~C() {}
    static int bar(int oops) { return 3*oops; }
};

class D: public C
{
protected:
    D(): C() {}
    virtual ~D() {}
};

class E: public D
{
public:
    E(): D() {}
    virtual ~E() {}
};

#endif // S_H

// Local Variables:
// mode: C++
// c-file-style: "stroustrup"
// indent-tabs-mode: nil
// End:
